Draft Upgrade/sv: Difference between revisions

From FreeCAD Documentation
(Created page with "{{GuiCommand/se|Name=Draft_Upgrade|Workbenches=Skiss|MenuLocation=Draft -> Upgrade}}")
(Updating to match new version of source page)
 
(23 intermediate revisions by 4 users not shown)
Line 1: Line 1:
<languages/>
{{GuiCommand/se|Name=Draft_Upgrade|Workbenches=[[Draft Module/se|Skiss]]|MenuLocation=Draft -> Upgrade}}


{{Docnav
==Description==
|[[Draft_Split|Split]]
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Split.svg
|IconR=Draft_Downgrade.svg
|IconC=Workbench_Draft.svg
}}


<div class="mw-translate-fuzzy">
This tool upgrades selected objects in different ways. If no object is selected, you will be invited to select one.
{{GuiCommand/sv|Name=Draft_Upgrade|Workbenches=[[Draft_Workbench/sv|Draft]], [[Arch_Workbench/sv|Arch]]|MenuLocation=Draft → Upgrade|Shortcut=U P|SeeAlso=[[Draft Downgrade/sv|Draft Downgrade]]}}
</div>

<span id="Description"></span>
==Beskrivning==

<div class="mw-translate-fuzzy">
Detta verktyg uppgraderar valda objekt på olika sätt. Om inget objekt är markerat, så ombes du att välja ett.
</div>


[[Image:Draft_Upgrade_example.jpg|400px]]
[[Image:Draft_Upgrade_example.jpg|400px]]
{{Caption|An open non-editable wire is upgraded to a closed wire, and then to a face. A closed non-editable square wire is also upgraded to a face. The two faces are then upgraded to create a compound, which is finally upgraded to a single editable Draft Wire.}}


<span id="Usage"></span>
==How to use==
==Bruk==


# Select one or more objects you wish to upgrade
# Optionally select one or more objects.
# There are several ways to invoke the command:
# Press the {{KEY|[[Image:Draft Upgrade.png|16px]] [[Draft Upgrade]]}} button or press {{KEY|U}} then {{KEY|P}} keys
#* Press the {{Button|[[Image:Draft_Upgrade.svg|16px]] [[Draft_Upgrade|Upgrade]]}} button.
#* Select the {{MenuCommand|Modification → [[Image:Draft_Upgrade.svg|16px]] Upgrade}} option from the menu.
#* Use the keyboard shortcut: {{KEY|U}} then {{KEY|P}}.
# If you have not yet selected an object: select an object in the [[3D_view|3D view]].


==Options==
==Notes==


* [[Draft_Line|Draft Lines]] and [[Draft_Wire|Draft Wires]] can be joined with this command, but also with the [[Draft_Join|Draft Join]] command or the [[Draft_Wire|Draft Wire]] command.
The selected objects are modified/upgraded according to the following conditions (in order):
* if there are more than one face in the selection, the faces are merged (union)
* if there is only one face in the selection, nothing is done
* if there is only one open wire in the selection, it gets closed
* if there are only edges in the selection, all edges are joined into a wire (closed if possible)
* if none of the above is possible, a compound object is created


==Scripting==
==Scripting==


<div class="mw-translate-fuzzy">
The upgrade tool can be used from python scripts and [[macros]] like this:
==Skript==
</div>


To upgrade objects use the {{incode|upgrade}} method of the Draft module.
<syntaxhighlight>
Draft.upgrade(objects, delete=False, force=None)
</syntaxhighlight>


{{Code|code=
* Upgrades the given object(s) (can be an object or a list of objects).
upgrade_list = upgrade(objects, delete=False, force=None)
* If delete is True, old objects are deleted.
}}
* The force attribute can be used to force a certain way of upgrading. It can be: makeCompound, closeGroupWires, makeSolid, closeWire, turnToParts, makeFusion, makeShell, makeFaces, draftify, joinFaces, makeSketchFace, makeWires
* Returns a dictionnary containing two lists, a list of new objects and a list of objects to be deleted


* {{incode|objects}} contains the objects to be upgraded. It is either a single object or a list of objects.
Some of the operations of the Upgrade tool can also be made with the [[Part Fuse]] or [[Draft Wire]] tools.
* If {{incode|delete}} is {{incode|True}} the source objects are deleted.
* {{incode|force}} forces a certain way of upgrading by calling a specific internal function. It can be: {{incode|"makeCompound"}}, {{incode|"closeGroupWires"}}, {{incode|"makeSolid"}}, {{incode|"closeWire"}}, {{incode|"turnToParts"}}, {{incode|"makeFusion"}}, {{incode|"makeShell"}}, {{incode|"makeFaces"}}, {{incode|"draftify"}}, {{incode|"joinFaces"}}, {{incode|"makeSketchFace"}}, {{incode|"makeWires"}} or {{incode|"turnToLine"}}.
* {{incode|upgrade_list}} is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If {{incode|delete}} is {{incode|True}} the second list is empty.


Example:
Example:


{{Code|code=
<syntaxhighlight>
import FreeCAD as App
import Draft
import Draft
mycircle = Draft.makeCircle(2)
face1 = Draft.upgrade([mycircle],True)
</syntaxhighlight>


doc = App.newDocument()
<languages/>

circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()

add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=False)

line1 = Draft.make_line(App.Vector(2000, 0, 0), App.Vector(2500, 1500, 0))
line2 = Draft.make_line(App.Vector(2500, 1500, 0), App.Vector(3000, -1000, 0))
doc.recompute()

add_list2, delete_list2 = Draft.upgrade([line1, line2], delete=False)

simple_wire = add_list2[0]
add_list3, delete_list3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = add_list3[0]
add_list4, delete_list4 = Draft.upgrade(closed_wire, delete=False)

face = add_list4[0]
add_list5, delete_list5 = Draft.upgrade(face, delete=False)

doc.recompute()
}}


{{Docnav
|[[Draft_Split|Split]]
|[[Draft_Downgrade|Downgrade]]
|[[Draft_Workbench|Draft]]
|IconL=Draft_Split.svg
|IconR=Draft_Downgrade.svg
|IconC=Workbench_Draft.svg
}}

{{Draft Tools navi{{#translation:}}}}
{{Userdocnavi{{#translation:}}}}

Latest revision as of 19:53, 7 December 2023

Draft_Upgrade

Menyplacering
Draft → Upgrade
Arbetsbänkar
Draft, Arch
Standard genväg
U P
Introducerad i version
-
Se även
Draft Downgrade

Beskrivning

Detta verktyg uppgraderar valda objekt på olika sätt. Om inget objekt är markerat, så ombes du att välja ett.

An open non-editable wire is upgraded to a closed wire, and then to a face. A closed non-editable square wire is also upgraded to a face. The two faces are then upgraded to create a compound, which is finally upgraded to a single editable Draft Wire.

Bruk

  1. Optionally select one or more objects.
  2. There are several ways to invoke the command:
    • Press the Upgrade button.
    • Select the Modification → Upgrade option from the menu.
    • Use the keyboard shortcut: U then P.
  3. If you have not yet selected an object: select an object in the 3D view.

Notes

Scripting

Skript

To upgrade objects use the upgrade method of the Draft module.

upgrade_list = upgrade(objects, delete=False, force=None)
  • objects contains the objects to be upgraded. It is either a single object or a list of objects.
  • If delete is True the source objects are deleted.
  • force forces a certain way of upgrading by calling a specific internal function. It can be: "makeCompound", "closeGroupWires", "makeSolid", "closeWire", "turnToParts", "makeFusion", "makeShell", "makeFaces", "draftify", "joinFaces", "makeSketchFace", "makeWires" or "turnToLine".
  • upgrade_list is returned. It is a list containing two lists: a list of new objects and a list of objects to be deleted. If delete is True the second list is empty.

Example:

import FreeCAD as App
import Draft

doc = App.newDocument()

circle = Draft.make_circle(1000)
rectangle = Draft.make_rectangle(2000, 800)
doc.recompute()

add_list1, delete_list1 = Draft.upgrade([circle, rectangle], delete=False)

line1 = Draft.make_line(App.Vector(2000, 0, 0), App.Vector(2500, 1500, 0))
line2 = Draft.make_line(App.Vector(2500, 1500, 0), App.Vector(3000, -1000, 0))
doc.recompute()

add_list2, delete_list2 = Draft.upgrade([line1, line2], delete=False)

simple_wire = add_list2[0]
add_list3, delete_list3 = Draft.upgrade(simple_wire, delete=False)

closed_wire = add_list3[0]
add_list4, delete_list4 = Draft.upgrade(closed_wire, delete=False)

face = add_list4[0]
add_list5, delete_list5 = Draft.upgrade(face, delete=False)

doc.recompute()